// Lsung mit Tabelle
// (aktueller Zustand, Ereignis) --> neuer Zustand.
// bersichtlich und effizient; die Methode der Wahl.

#include "io430.h"

enum State {off, half, full, failure, numberOfStates};
typedef enum State State;

enum Event {up, down, error, numberOfEvents};
typedef enum Event Event;

State nextState(State currentState, Event theEvent);
          
int main(void)
{
  State currentState = off;
  currentState = nextState(currentState, up);
  currentState = nextState(currentState, up);
  currentState = nextState(currentState, up);
  currentState = nextState(currentState, error);
  
  return 0;
}

// Dieses Array besser als const deklarieren
// und in Funktion nextState verstecken.
State transitions[numberOfStates][numberOfEvents] =
{
  {half, off, failure},
  {full, off, failure},
  {full, half, failure},
  {failure, failure, failure}
};

State nextState(State currentState, Event theEvent)
{
  return transitions[currentState][theEvent];
}