// Lsung mit einer Tabelle
// (aktueller Zustand, neuer Zustand) --> Ereignis.
// bersichtlich, verlangt aber Suche nach Ereignis;
// auerdem kann derselbe bergang nicht von mehreren
// verschiedenen Ereignissen bewirkt werden, denn in einer
// Tabellenzelle knnen nicht mehrere Events stehen.

#include "io430.h"

enum State {off, half, full, failure, numberOfStates};
typedef enum State State;

enum Event {up, down, error, noAction};
typedef enum Event Event;

State nextState(State currentState, Event theEvent);

int main(void)
{
  State currentState = off;
  currentState = nextState(currentState, up);
  currentState = nextState(currentState, error);
  
  return 0;
}

// Dieses Array besser als const deklarieren
// und in Funktion nextState verstecken.
Event transitions[numberOfStates][numberOfStates] =
{
  {noAction, up, noAction, error},
  {down, noAction, up, error},
  {noAction, down, noAction, error},
  {noAction, noAction, noAction, error}
};

State nextState(State currentState, Event theEvent)
{
  State s = off;
  for(int i = 0; i < numberOfStates; i++)
  {
    if(transitions[currentState][i] == theEvent)
    {
      s = (State)i;
      break;
    }
  }
  return s;
}